# <H1 align="center">ORCHESTRATOR</h1>

## General information
<p>  Robot Orchestrator - a service for launching robots according to a schedule and / or some events. Access to the orchestrator is carried out by pressing a   ![Screenshot](img/Orkes_1.png) button in the control panel of the main studio window. After clicking on the button, a window will open allowing you to publish a new robot and / or adjust the launch schedule of already published robots.</p> 
<H1 align="center">![Screenshot](img/Orkes_2.png)</h1> 
<p>  Orchestrator consists of three parts and a button for publishing the current robot.
<p>  Parts of the orchestrator: 
<p>  ●	Tasks - the part that allows you to create a new task;
<p>  ●	Robots - the list of all published robots by the user;
<p>  ●	List of tasks - the list of all tasks published by the user.
<p>  The «Publish current robot» adds an already active robot to the list of published robots.
<p>  After creating all tasks you just need to close the orchestrator window.
<p>  For the orchestrator to work you need to install the Lexema-RPA Client software that scans all created tasks and launches them according to the schedule in the background. To download it  you need to visit this -   <a href="http://lexema.ru/solutions/lexema-rpa-programmnye-roboty/lexema-rpa-studio/"> website </a> and select «Download Lexema-RPA Client». User manual for the software is also there.
## Creating a new task 
<p>  To create a schedule for the robot execution you need to create a task. To configure a task you need to fill in 5 fields – this is the name of the task, choosing a robot from already published, launch time of the robot, amount of retries and launch interval. 
<H1 align="center">![Screenshot](img/Orkes_3.png)</h1> 
<p>  Task name. The name of the task to run a specific robot, an identifier by which it will be more convenient to navigate among all your tasks.
<p>  Robot. Choosing a robot to which the task is gonna be applied to. The field is a drop down list with all your published robots
<H1 align="center">![Screenshot](img/Orkes_4.png)</h1>
<p>  First launch. The time of  the first launch of the robot after which it's going to be launched with an interval. The date and time is chosen.
<p>  Retries. Total number of robot retries. If you don't need to launch the robot more than one time you should put 0 in this field. If you need to launch the robot twice a day throughout the week then the amount of retries equals 2*7-1 = 13.
<p>  Launch time. Time after which the robot needs to be restarted (if there are retries (restarts). To configure this field press the arrow button on the right.
<H1 align="center">![Screenshot](img/Orkes_5.png)</h1>
<p>  By clicking on it, an auxiliary window for selecting the interval will open.
<H1 align="center">![Screenshot](img/Orkes_6.png)</h1>
<p>  If you need the robot to run on the 25th of every month, you need to set the closest 25th of the month, and in the interval settings set interval to «1» in the «Month» line, then the robot will restart every month.
<p>  The same interval is set between every restart (retry). If you need to run the robot with different intervals, then you need to create multiple tasks of robots execution, for example if you need to run the robot at 10:00 am and at 1:00 pm of the same day throughout the week, then you need to create two tasks, amount of retries of which equals 6 (every day not counting the day of the first start (run), interval of launch – 24 hours or 1 day, the only difference between these tasks is the time of launch – first one at 10:00 am, and the second one – at 13:00.
<p>  After filling in all fields in the interval window and pressing the «Save» button, in the «Interval» field a line like this will show up «year:month:day:hour:minutes:seconds», for example if you set the interval for 12 hours it will look like this: «0:0:0:12:0:0». The «Interval» field is a necessary field, if the amount of restarts differs from one.
<p>  An example of a completed task:
<H1 align="center">![Screenshot](img/Orkes_7.png)</h1>
<p>  By clicking the «Add» button, that is located below the fields for configuring tasks, the task is gonna be added to the task list.
<H1 align="center">![Screenshot](img/Orkes_8.png)</h1>
<p>  To edit an existing task you need to find it in the list and click on it  (1). Then the fields for configuring the task will fill in with the appropriate fields. Then, after editing the fields (2), you need to press the «Edit» button and the changes will be saved (3).
<H1 align="center">![Screenshot](img/Orkes_9.png)</h1>
<p>  To delete a task you need to find it from the list and then press the «Delete» button.